/*
* Copyright © 2010 Red Hat, Inc.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*           http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

package com.redhat.rhevm.api.mock.resource;

import java.util.concurrent.Executor;

import com.redhat.rhevm.api.model.User;
import com.redhat.rhevm.api.resource.AssignedPermissionsResource;
import com.redhat.rhevm.api.resource.AssignedRolesResource;
import com.redhat.rhevm.api.resource.AssignedTagsResource;
import com.redhat.rhevm.api.resource.UserResource;
import com.redhat.rhevm.api.common.resource.UriInfoProvider;
import com.redhat.rhevm.api.common.util.JAXBHelper;
import com.redhat.rhevm.api.common.util.LinkHelper;


public class MockUserResource extends AbstractMockResource<User> implements UserResource {
    /* FIXME: would like to do:
     * private @Context UriInfo uriInfo;
     */

    /**
     * Package-protected ctor, never needs to be instantiated by JAX-RS framework.
     *
     * @param user     encapsulated user
     * @param executor executor used for asynchronous actions
     */
    MockUserResource(String id, Executor executor, UriInfoProvider uriProvider) {
        super(id, executor, uriProvider);
    }

    // FIXME: this needs to be atomic
    public void updateModel(User user) {
        // update writable fields only
        if (user.isSetName()) {
            getModel().setName(user.getName());
        }
        if (user.isSetUserName()) {
            getModel().setUserName(user.getUserName());
        }
    }

    public User addLinks() {
        return LinkHelper.addLinks(getUriInfo(), JAXBHelper.clone(OBJECT_FACTORY.createUser(getModel())));
    }

    /* FIXME: kill uriInfo param, make href auto-generated? */
    @Override
    public User get() {
        return addLinks();
    }

    @Override
    public AssignedRolesResource getRolesResource() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public AssignedPermissionsResource getPermissionsResource() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public AssignedTagsResource getTagsResource() {
        // TODO Auto-generated method stub
        return null;
    }
}
